(function() {
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  PuppetEnterpriseConsole.Node = (function() {
    var name, value, _fn, _ref;
    __extends(Node, Batman.Model);
    function Node() {
      Node.__super__.constructor.apply(this, arguments);
    }
    Node.global(true);
    Node.persist(Batman.RestStorage);
    Node.url = '/live-management/lm/nodes';
    Node.primaryKey = 'name';
    Node.encode('name');
    Node.on('loading', function() {
      return setTimeout((__bind(function() {
        return this.set('batmanState', 'loading');
      }, this)), 0);
    });
    Node.on('loaded', function() {
      return setTimeout((__bind(function() {
        return this.set('batmanState', 'loaded');
      }, this)), 0);
    });
    Node.classAccessor('filtered', function() {
      var load;
      load = __bind(function(set) {
        this.unset('loadingError');
        this.load(this.get('filters') || {}, __bind(function(error, data) {
          var node, _i, _len;
          if (error) {
            this.set('loadingError', error);
            return this.fire('loaded');
          } else {
            for (_i = 0, _len = data.length; _i < _len; _i++) {
              node = data[_i];
              node.set('isSelected', true);
            }
            return set.add.apply(set, data);
          }
        }, this));
        return set;
      }, this);
      return load(new Batman.Set());
    });
    Node.classAccessor('selected', function() {
      return this.get('filtered').filter(function(node) {
        return node.get('isSelected');
      });
    });
    Node.classAccessor('nodeSetID', function() {
      var key;
      key = null;
      $.ajax('/live-management/lm/nodeset', {
        async: false,
        type: 'POST',
        data: {
          nodes: this.get('selected').map(function(n) {
            return n.get('name');
          })
        },
        success: __bind(function(data) {
          return key = data;
        }, this)
      });
      return key;
    });
    Node.validateAndGetNodeSetID = function() {
      var key;
      key = this.get('nodeSetID');
      $.ajax('/live-management/lm/nodeset', {
        async: false,
        type: 'HEAD',
        data: {
          key: key
        },
        statusCode: {
          400: __bind(function() {
            return this.property('selected').fire();
          }, this)
        }
      });
      return this.get('nodeSetID');
    };
    _ref = {
      selectAll: true,
      selectNone: false
    };
    _fn = __bind(function(name, value) {
      return this[name] = function() {
        this.property('selected').isolate();
        this.get('filtered').forEach(function(node) {
          return node.set('isSelected', value);
        });
        this.property('selected').expose();
        return this.property('selected').fire();
      };
    }, Node);
    for (name in _ref) {
      value = _ref[name];
      _fn(name, value);
    }
    Node.prototype.toggleSelected = function() {
      return this.set('isSelected', !this.get('isSelected'));
    };
    return Node;
  }).call(this);
}).call(this);
